C
C Copyright (c) Erik Lindahl, David van der Spoel 2003
C This file is generated automatically at compile time
C by the program mknb in the Gromacs distribution.
C
C Options used for generating this file:
C Language:         Take a wild guess
C Precision:        single
C Threads:          no
C Software invsqrt: yes
C PowerPC invsqrt:  no
C Prefetch forces:  no
C Comments:         no




C
C Gromacs nonbonded kernel nb_kernel102
C Coulomb interaction:     Normal Coulomb
C VdW interaction:         Not calculated
C water optimization:      pairs of SPC/TIP3P interactions
C Calculate forces:        yes
C
      subroutine nb_kernel102(
     &                          nri,
     &                          iinr,
     &                          jindex,
     &                          jjnr,
     &                          shift,
     &                          shiftvec,
     &                          fshift,
     &                          gid,
     &                          pos,
     &                          faction,
     &                          charge,
     &                          facel,
     &                          krf,
     &                          crf,
     &                          Vc,
     &                          type,
     &                          ntype,
     &                          vdwparam,
     &                          Vvdw,
     &                          tabscale,
     &                          VFtab,
     &                          invsqrta,
     &                          dvda,
     &                          gbtabscale,
     &                          GBtab,
     &                          nthreads,
     &                          count,
     &                          mtx,
     &                          outeriter,
     &                          inneriter,
     &                          work)
      implicit      none
      integer*4     nri,iinr(*),jindex(*),jjnr(*),shift(*)
      real*4        shiftvec(*),fshift(*),pos(*),faction(*)
      integer*4     gid(*),type(*),ntype
      real*4        charge(*),facel,krf,crf,Vc(*),vdwparam(*)
      real*4        Vvdw(*),tabscale,VFtab(*)
      real*4        invsqrta(*),dvda(*),gbtabscale,GBtab(*)
      integer*4     nthreads,count,mtx,outeriter,inneriter
      real*4        work(*)

      integer*4     n,ii,is3,ii3,k,nj0,nj1,jnr,j3,ggid
      real*4        shX,shY,shZ
      real*4        fscal,tx,ty,tz
      real*4        rinvsq
      real*4        qq,vcoul,vctot
      real*4        ix1,iy1,iz1,fix1,fiy1,fiz1
      real*4        ix2,iy2,iz2,fix2,fiy2,fiz2
      real*4        ix3,iy3,iz3,fix3,fiy3,fiz3
      real*4        jx1,jy1,jz1,fjx1,fjy1,fjz1
      real*4        jx2,jy2,jz2,fjx2,fjy2,fjz2
      real*4        jx3,jy3,jz3,fjx3,fjy3,fjz3
      real*4        dx11,dy11,dz11,rsq11,rinv11
      real*4        dx12,dy12,dz12,rsq12,rinv12
      real*4        dx13,dy13,dz13,rsq13,rinv13
      real*4        dx21,dy21,dz21,rsq21,rinv21
      real*4        dx22,dy22,dz22,rsq22,rinv22
      real*4        dx23,dy23,dz23,rsq23,rinv23
      real*4        dx31,dy31,dz31,rsq31,rinv31
      real*4        dx32,dy32,dz32,rsq32,rinv32
      real*4        dx33,dy33,dz33,rsq33,rinv33
      real*4        qO,qH,qqOO,qqOH,qqHH
      integer*4     fractshift
          parameter (fractshift = 12)
      integer*4     fractmask
          parameter (fractmask = 8388607)
      integer*4     expshift
          parameter (expshift = 23)
      integer*4     expmask
          parameter (expmask = 2139095040)
      integer*4     explsb
          parameter (explsb = 8388608)
      real*4        lu
      integer*4     iexp,addr
      integer*4     bval,result
      real*4        fval
      equivalence(bval,fval)
      equivalence(result,lu)
      integer*4     invsqrtexptab,invsqrtfracttab
      common /gmxinvsqrtdata/ invsqrtexptab(256),invsqrtfracttab(4096)

      ii               = iinr(1)+1       
      qO               = charge(ii)      
      qH               = charge(ii+1)    
      qqOO             = facel*qO*qO     
      qqOH             = facel*qO*qH     
      qqHH             = facel*qH*qH     

      nj1              = 0               
      
      do n=1,nri
        is3              = 3*shift(n)+1    
        shX              = shiftvec(is3)   
        shY              = shiftvec(is3+1) 
        shZ              = shiftvec(is3+2) 
        nj0              = jindex(n)+1     
        nj1              = jindex(n+1)     
        ii               = iinr(n)+1       
        ii3              = 3*ii-2          
        ix1              = shX + pos(ii3+0)
        iy1              = shY + pos(ii3+1)
        iz1              = shZ + pos(ii3+2)
        ix2              = shX + pos(ii3+3)
        iy2              = shY + pos(ii3+4)
        iz2              = shZ + pos(ii3+5)
        ix3              = shX + pos(ii3+6)
        iy3              = shY + pos(ii3+7)
        iz3              = shZ + pos(ii3+8)
        vctot            = 0               
        fix1             = 0               
        fiy1             = 0               
        fiz1             = 0               
        fix2             = 0               
        fiy2             = 0               
        fiz2             = 0               
        fix3             = 0               
        fiy3             = 0               
        fiz3             = 0               
        
        do k=nj0,nj1
          jnr              = jjnr(k)+1       
          j3               = 3*jnr-2         
          jx1              = pos(j3+0)       
          jy1              = pos(j3+1)       
          jz1              = pos(j3+2)       
          jx2              = pos(j3+3)       
          jy2              = pos(j3+4)       
          jz2              = pos(j3+5)       
          jx3              = pos(j3+6)       
          jy3              = pos(j3+7)       
          jz3              = pos(j3+8)       
          dx11             = ix1 - jx1       
          dy11             = iy1 - jy1       
          dz11             = iz1 - jz1       
          rsq11            = dx11*dx11+dy11*dy11+dz11*dz11
          dx12             = ix1 - jx2       
          dy12             = iy1 - jy2       
          dz12             = iz1 - jz2       
          rsq12            = dx12*dx12+dy12*dy12+dz12*dz12
          dx13             = ix1 - jx3       
          dy13             = iy1 - jy3       
          dz13             = iz1 - jz3       
          rsq13            = dx13*dx13+dy13*dy13+dz13*dz13
          dx21             = ix2 - jx1       
          dy21             = iy2 - jy1       
          dz21             = iz2 - jz1       
          rsq21            = dx21*dx21+dy21*dy21+dz21*dz21
          dx22             = ix2 - jx2       
          dy22             = iy2 - jy2       
          dz22             = iz2 - jz2       
          rsq22            = dx22*dx22+dy22*dy22+dz22*dz22
          dx23             = ix2 - jx3       
          dy23             = iy2 - jy3       
          dz23             = iz2 - jz3       
          rsq23            = dx23*dx23+dy23*dy23+dz23*dz23
          dx31             = ix3 - jx1       
          dy31             = iy3 - jy1       
          dz31             = iz3 - jz1       
          rsq31            = dx31*dx31+dy31*dy31+dz31*dz31
          dx32             = ix3 - jx2       
          dy32             = iy3 - jy2       
          dz32             = iz3 - jz2       
          rsq32            = dx32*dx32+dy32*dy32+dz32*dz32
          dx33             = ix3 - jx3       
          dy33             = iy3 - jy3       
          dz33             = iz3 - jz3       
          rsq33            = dx33*dx33+dy33*dy33+dz33*dz33
          fval             = rsq11           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv11           = (0.5*lu*(3.0-((rsq11*lu)*lu)))
          fval             = rsq12           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv12           = (0.5*lu*(3.0-((rsq12*lu)*lu)))
          fval             = rsq13           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv13           = (0.5*lu*(3.0-((rsq13*lu)*lu)))
          fval             = rsq21           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv21           = (0.5*lu*(3.0-((rsq21*lu)*lu)))
          fval             = rsq22           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv22           = (0.5*lu*(3.0-((rsq22*lu)*lu)))
          fval             = rsq23           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv23           = (0.5*lu*(3.0-((rsq23*lu)*lu)))
          fval             = rsq31           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv31           = (0.5*lu*(3.0-((rsq31*lu)*lu)))
          fval             = rsq32           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv32           = (0.5*lu*(3.0-((rsq32*lu)*lu)))
          fval             = rsq33           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv33           = (0.5*lu*(3.0-((rsq33*lu)*lu)))
          qq               = qqOO            
          rinvsq           = rinv11*rinv11   
          vcoul            = qq*rinv11       
          vctot            = vctot+vcoul     
          fscal            = (vcoul)*rinvsq  
          tx               = fscal*dx11      
          ty               = fscal*dy11      
          tz               = fscal*dz11      
          fix1             = fix1 + tx       
          fiy1             = fiy1 + ty       
          fiz1             = fiz1 + tz       
          fjx1             = faction(j3+0) - tx
          fjy1             = faction(j3+1) - ty
          fjz1             = faction(j3+2) - tz
          qq               = qqOH            
          rinvsq           = rinv12*rinv12   
          vcoul            = qq*rinv12       
          vctot            = vctot+vcoul     
          fscal            = (vcoul)*rinvsq  
          tx               = fscal*dx12      
          ty               = fscal*dy12      
          tz               = fscal*dz12      
          fix1             = fix1 + tx       
          fiy1             = fiy1 + ty       
          fiz1             = fiz1 + tz       
          fjx2             = faction(j3+3) - tx
          fjy2             = faction(j3+4) - ty
          fjz2             = faction(j3+5) - tz
          qq               = qqOH            
          rinvsq           = rinv13*rinv13   
          vcoul            = qq*rinv13       
          vctot            = vctot+vcoul     
          fscal            = (vcoul)*rinvsq  
          tx               = fscal*dx13      
          ty               = fscal*dy13      
          tz               = fscal*dz13      
          fix1             = fix1 + tx       
          fiy1             = fiy1 + ty       
          fiz1             = fiz1 + tz       
          fjx3             = faction(j3+6) - tx
          fjy3             = faction(j3+7) - ty
          fjz3             = faction(j3+8) - tz
          qq               = qqOH            
          rinvsq           = rinv21*rinv21   
          vcoul            = qq*rinv21       
          vctot            = vctot+vcoul     
          fscal            = (vcoul)*rinvsq  
          tx               = fscal*dx21      
          ty               = fscal*dy21      
          tz               = fscal*dz21      
          fix2             = fix2 + tx       
          fiy2             = fiy2 + ty       
          fiz2             = fiz2 + tz       
          fjx1             = fjx1 - tx       
          fjy1             = fjy1 - ty       
          fjz1             = fjz1 - tz       
          qq               = qqHH            
          rinvsq           = rinv22*rinv22   
          vcoul            = qq*rinv22       
          vctot            = vctot+vcoul     
          fscal            = (vcoul)*rinvsq  
          tx               = fscal*dx22      
          ty               = fscal*dy22      
          tz               = fscal*dz22      
          fix2             = fix2 + tx       
          fiy2             = fiy2 + ty       
          fiz2             = fiz2 + tz       
          fjx2             = fjx2 - tx       
          fjy2             = fjy2 - ty       
          fjz2             = fjz2 - tz       
          qq               = qqHH            
          rinvsq           = rinv23*rinv23   
          vcoul            = qq*rinv23       
          vctot            = vctot+vcoul     
          fscal            = (vcoul)*rinvsq  
          tx               = fscal*dx23      
          ty               = fscal*dy23      
          tz               = fscal*dz23      
          fix2             = fix2 + tx       
          fiy2             = fiy2 + ty       
          fiz2             = fiz2 + tz       
          fjx3             = fjx3 - tx       
          fjy3             = fjy3 - ty       
          fjz3             = fjz3 - tz       
          qq               = qqOH            
          rinvsq           = rinv31*rinv31   
          vcoul            = qq*rinv31       
          vctot            = vctot+vcoul     
          fscal            = (vcoul)*rinvsq  
          tx               = fscal*dx31      
          ty               = fscal*dy31      
          tz               = fscal*dz31      
          fix3             = fix3 + tx       
          fiy3             = fiy3 + ty       
          fiz3             = fiz3 + tz       
          faction(j3+0)    = fjx1 - tx       
          faction(j3+1)    = fjy1 - ty       
          faction(j3+2)    = fjz1 - tz       
          qq               = qqHH            
          rinvsq           = rinv32*rinv32   
          vcoul            = qq*rinv32       
          vctot            = vctot+vcoul     
          fscal            = (vcoul)*rinvsq  
          tx               = fscal*dx32      
          ty               = fscal*dy32      
          tz               = fscal*dz32      
          fix3             = fix3 + tx       
          fiy3             = fiy3 + ty       
          fiz3             = fiz3 + tz       
          faction(j3+3)    = fjx2 - tx       
          faction(j3+4)    = fjy2 - ty       
          faction(j3+5)    = fjz2 - tz       
          qq               = qqHH            
          rinvsq           = rinv33*rinv33   
          vcoul            = qq*rinv33       
          vctot            = vctot+vcoul     
          fscal            = (vcoul)*rinvsq  
          tx               = fscal*dx33      
          ty               = fscal*dy33      
          tz               = fscal*dz33      
          fix3             = fix3 + tx       
          fiy3             = fiy3 + ty       
          fiz3             = fiz3 + tz       
          faction(j3+6)    = fjx3 - tx       
          faction(j3+7)    = fjy3 - ty       
          faction(j3+8)    = fjz3 - tz       
        end do
        
        faction(ii3+0)   = faction(ii3+0) + fix1
        faction(ii3+1)   = faction(ii3+1) + fiy1
        faction(ii3+2)   = faction(ii3+2) + fiz1
        faction(ii3+3)   = faction(ii3+3) + fix2
        faction(ii3+4)   = faction(ii3+4) + fiy2
        faction(ii3+5)   = faction(ii3+5) + fiz2
        faction(ii3+6)   = faction(ii3+6) + fix3
        faction(ii3+7)   = faction(ii3+7) + fiy3
        faction(ii3+8)   = faction(ii3+8) + fiz3
        fshift(is3)      = fshift(is3)+fix1+fix2+fix3
        fshift(is3+1)    = fshift(is3+1)+fiy1+fiy2+fiy3
        fshift(is3+2)    = fshift(is3+2)+fiz1+fiz2+fiz3
        ggid             = gid(n)+1        
        Vc(ggid)         = Vc(ggid) + vctot
      end do
      
      outeriter        = nri             
      inneriter        = nj1             
      return
      end






C
C Gromacs nonbonded kernel nb_kernel102nf
C Coulomb interaction:     Normal Coulomb
C VdW interaction:         Not calculated
C water optimization:      pairs of SPC/TIP3P interactions
C Calculate forces:        no
C
      subroutine nb_kernel102nf(
     &                          nri,
     &                          iinr,
     &                          jindex,
     &                          jjnr,
     &                          shift,
     &                          shiftvec,
     &                          fshift,
     &                          gid,
     &                          pos,
     &                          faction,
     &                          charge,
     &                          facel,
     &                          krf,
     &                          crf,
     &                          Vc,
     &                          type,
     &                          ntype,
     &                          vdwparam,
     &                          Vvdw,
     &                          tabscale,
     &                          VFtab,
     &                          invsqrta,
     &                          dvda,
     &                          gbtabscale,
     &                          GBtab,
     &                          nthreads,
     &                          count,
     &                          mtx,
     &                          outeriter,
     &                          inneriter,
     &                          work)
      implicit      none
      integer*4     nri,iinr(*),jindex(*),jjnr(*),shift(*)
      real*4        shiftvec(*),fshift(*),pos(*),faction(*)
      integer*4     gid(*),type(*),ntype
      real*4        charge(*),facel,krf,crf,Vc(*),vdwparam(*)
      real*4        Vvdw(*),tabscale,VFtab(*)
      real*4        invsqrta(*),dvda(*),gbtabscale,GBtab(*)
      integer*4     nthreads,count,mtx,outeriter,inneriter
      real*4        work(*)

      integer*4     n,ii,is3,ii3,k,nj0,nj1,jnr,j3,ggid
      real*4        shX,shY,shZ
      real*4        qq,vcoul,vctot
      real*4        ix1,iy1,iz1
      real*4        ix2,iy2,iz2
      real*4        ix3,iy3,iz3
      real*4        jx1,jy1,jz1
      real*4        jx2,jy2,jz2
      real*4        jx3,jy3,jz3
      real*4        dx11,dy11,dz11,rsq11,rinv11
      real*4        dx12,dy12,dz12,rsq12,rinv12
      real*4        dx13,dy13,dz13,rsq13,rinv13
      real*4        dx21,dy21,dz21,rsq21,rinv21
      real*4        dx22,dy22,dz22,rsq22,rinv22
      real*4        dx23,dy23,dz23,rsq23,rinv23
      real*4        dx31,dy31,dz31,rsq31,rinv31
      real*4        dx32,dy32,dz32,rsq32,rinv32
      real*4        dx33,dy33,dz33,rsq33,rinv33
      real*4        qO,qH,qqOO,qqOH,qqHH
      integer*4     fractshift
          parameter (fractshift = 12)
      integer*4     fractmask
          parameter (fractmask = 8388607)
      integer*4     expshift
          parameter (expshift = 23)
      integer*4     expmask
          parameter (expmask = 2139095040)
      integer*4     explsb
          parameter (explsb = 8388608)
      real*4        lu
      integer*4     iexp,addr
      integer*4     bval,result
      real*4        fval
      equivalence(bval,fval)
      equivalence(result,lu)
      integer*4     invsqrtexptab,invsqrtfracttab
      common /gmxinvsqrtdata/ invsqrtexptab(256),invsqrtfracttab(4096)

      ii               = iinr(1)+1       
      qO               = charge(ii)      
      qH               = charge(ii+1)    
      qqOO             = facel*qO*qO     
      qqOH             = facel*qO*qH     
      qqHH             = facel*qH*qH     

      nj1              = 0               
      
      do n=1,nri
        is3              = 3*shift(n)+1    
        shX              = shiftvec(is3)   
        shY              = shiftvec(is3+1) 
        shZ              = shiftvec(is3+2) 
        nj0              = jindex(n)+1     
        nj1              = jindex(n+1)     
        ii               = iinr(n)+1       
        ii3              = 3*ii-2          
        ix1              = shX + pos(ii3+0)
        iy1              = shY + pos(ii3+1)
        iz1              = shZ + pos(ii3+2)
        ix2              = shX + pos(ii3+3)
        iy2              = shY + pos(ii3+4)
        iz2              = shZ + pos(ii3+5)
        ix3              = shX + pos(ii3+6)
        iy3              = shY + pos(ii3+7)
        iz3              = shZ + pos(ii3+8)
        vctot            = 0               
        
        do k=nj0,nj1
          jnr              = jjnr(k)+1       
          j3               = 3*jnr-2         
          jx1              = pos(j3+0)       
          jy1              = pos(j3+1)       
          jz1              = pos(j3+2)       
          jx2              = pos(j3+3)       
          jy2              = pos(j3+4)       
          jz2              = pos(j3+5)       
          jx3              = pos(j3+6)       
          jy3              = pos(j3+7)       
          jz3              = pos(j3+8)       
          dx11             = ix1 - jx1       
          dy11             = iy1 - jy1       
          dz11             = iz1 - jz1       
          rsq11            = dx11*dx11+dy11*dy11+dz11*dz11
          dx12             = ix1 - jx2       
          dy12             = iy1 - jy2       
          dz12             = iz1 - jz2       
          rsq12            = dx12*dx12+dy12*dy12+dz12*dz12
          dx13             = ix1 - jx3       
          dy13             = iy1 - jy3       
          dz13             = iz1 - jz3       
          rsq13            = dx13*dx13+dy13*dy13+dz13*dz13
          dx21             = ix2 - jx1       
          dy21             = iy2 - jy1       
          dz21             = iz2 - jz1       
          rsq21            = dx21*dx21+dy21*dy21+dz21*dz21
          dx22             = ix2 - jx2       
          dy22             = iy2 - jy2       
          dz22             = iz2 - jz2       
          rsq22            = dx22*dx22+dy22*dy22+dz22*dz22
          dx23             = ix2 - jx3       
          dy23             = iy2 - jy3       
          dz23             = iz2 - jz3       
          rsq23            = dx23*dx23+dy23*dy23+dz23*dz23
          dx31             = ix3 - jx1       
          dy31             = iy3 - jy1       
          dz31             = iz3 - jz1       
          rsq31            = dx31*dx31+dy31*dy31+dz31*dz31
          dx32             = ix3 - jx2       
          dy32             = iy3 - jy2       
          dz32             = iz3 - jz2       
          rsq32            = dx32*dx32+dy32*dy32+dz32*dz32
          dx33             = ix3 - jx3       
          dy33             = iy3 - jy3       
          dz33             = iz3 - jz3       
          rsq33            = dx33*dx33+dy33*dy33+dz33*dz33
          fval             = rsq11           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv11           = (0.5*lu*(3.0-((rsq11*lu)*lu)))
          fval             = rsq12           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv12           = (0.5*lu*(3.0-((rsq12*lu)*lu)))
          fval             = rsq13           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv13           = (0.5*lu*(3.0-((rsq13*lu)*lu)))
          fval             = rsq21           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv21           = (0.5*lu*(3.0-((rsq21*lu)*lu)))
          fval             = rsq22           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv22           = (0.5*lu*(3.0-((rsq22*lu)*lu)))
          fval             = rsq23           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv23           = (0.5*lu*(3.0-((rsq23*lu)*lu)))
          fval             = rsq31           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv31           = (0.5*lu*(3.0-((rsq31*lu)*lu)))
          fval             = rsq32           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv32           = (0.5*lu*(3.0-((rsq32*lu)*lu)))
          fval             = rsq33           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv33           = (0.5*lu*(3.0-((rsq33*lu)*lu)))
          qq               = qqOO            
          vcoul            = qq*rinv11       
          vctot            = vctot+vcoul     
          qq               = qqOH            
          vcoul            = qq*rinv12       
          vctot            = vctot+vcoul     
          qq               = qqOH            
          vcoul            = qq*rinv13       
          vctot            = vctot+vcoul     
          qq               = qqOH            
          vcoul            = qq*rinv21       
          vctot            = vctot+vcoul     
          qq               = qqHH            
          vcoul            = qq*rinv22       
          vctot            = vctot+vcoul     
          qq               = qqHH            
          vcoul            = qq*rinv23       
          vctot            = vctot+vcoul     
          qq               = qqOH            
          vcoul            = qq*rinv31       
          vctot            = vctot+vcoul     
          qq               = qqHH            
          vcoul            = qq*rinv32       
          vctot            = vctot+vcoul     
          qq               = qqHH            
          vcoul            = qq*rinv33       
          vctot            = vctot+vcoul     
        end do
        
        ggid             = gid(n)+1        
        Vc(ggid)         = Vc(ggid) + vctot
      end do
      
      outeriter        = nri             
      inneriter        = nj1             
      return
      end



