C
C Copyright (c) Erik Lindahl, David van der Spoel 2003
C This file is generated automatically at compile time
C by the program mknb in the Gromacs distribution.
C
C Options used for generating this file:
C Language:         Take a wild guess
C Precision:        single
C Threads:          no
C Software invsqrt: yes
C PowerPC invsqrt:  no
C Prefetch forces:  no
C Comments:         no




C
C Gromacs nonbonded kernel nb_kernel220
C Coulomb interaction:     Reaction field
C VdW interaction:         Buckingham
C water optimization:      No
C Calculate forces:        yes
C
      subroutine nb_kernel220(
     &                          nri,
     &                          iinr,
     &                          jindex,
     &                          jjnr,
     &                          shift,
     &                          shiftvec,
     &                          fshift,
     &                          gid,
     &                          pos,
     &                          faction,
     &                          charge,
     &                          facel,
     &                          krf,
     &                          crf,
     &                          Vc,
     &                          type,
     &                          ntype,
     &                          vdwparam,
     &                          Vvdw,
     &                          tabscale,
     &                          VFtab,
     &                          invsqrta,
     &                          dvda,
     &                          gbtabscale,
     &                          GBtab,
     &                          nthreads,
     &                          count,
     &                          mtx,
     &                          outeriter,
     &                          inneriter,
     &                          work)
      implicit      none
      integer*4     nri,iinr(*),jindex(*),jjnr(*),shift(*)
      real*4        shiftvec(*),fshift(*),pos(*),faction(*)
      integer*4     gid(*),type(*),ntype
      real*4        charge(*),facel,krf,crf,Vc(*),vdwparam(*)
      real*4        Vvdw(*),tabscale,VFtab(*)
      real*4        invsqrta(*),dvda(*),gbtabscale,GBtab(*)
      integer*4     nthreads,count,mtx,outeriter,inneriter
      real*4        work(*)

      integer*4     n,ii,is3,ii3,k,nj0,nj1,jnr,j3,ggid
      real*4        shX,shY,shZ
      real*4        fscal,tx,ty,tz
      real*4        rinvsq
      real*4        iq
      real*4        qq,vcoul,vctot
      integer*4     nti
      integer*4     tj
      real*4        rinvsix
      real*4        Vvdw6,Vvdwtot
      real*4        krsq
      real*4        Vvdwexp,br
      real*4        ix1,iy1,iz1,fix1,fiy1,fiz1
      real*4        jx1,jy1,jz1
      real*4        dx11,dy11,dz11,rsq11,rinv11
      real*4        c6,cexp1,cexp2
      integer*4     fractshift
          parameter (fractshift = 12)
      integer*4     fractmask
          parameter (fractmask = 8388607)
      integer*4     expshift
          parameter (expshift = 23)
      integer*4     expmask
          parameter (expmask = 2139095040)
      integer*4     explsb
          parameter (explsb = 8388608)
      real*4        lu
      integer*4     iexp,addr
      integer*4     bval,result
      real*4        fval
      equivalence(bval,fval)
      equivalence(result,lu)
      integer*4     invsqrtexptab,invsqrtfracttab
      common /gmxinvsqrtdata/ invsqrtexptab(256),invsqrtfracttab(4096)

      nj1              = 0               
      
      do n=1,nri
        is3              = 3*shift(n)+1    
        shX              = shiftvec(is3)   
        shY              = shiftvec(is3+1) 
        shZ              = shiftvec(is3+2) 
        nj0              = jindex(n)+1     
        nj1              = jindex(n+1)     
        ii               = iinr(n)+1       
        ii3              = 3*ii-2          
        ix1              = shX + pos(ii3+0)
        iy1              = shY + pos(ii3+1)
        iz1              = shZ + pos(ii3+2)
        iq               = facel*charge(ii)
        nti              = 3*ntype*type(ii)
        vctot            = 0               
        Vvdwtot          = 0               
        fix1             = 0               
        fiy1             = 0               
        fiz1             = 0               
        
        do k=nj0,nj1
          jnr              = jjnr(k)+1       
          j3               = 3*jnr-2         
          jx1              = pos(j3+0)       
          jy1              = pos(j3+1)       
          jz1              = pos(j3+2)       
          dx11             = ix1 - jx1       
          dy11             = iy1 - jy1       
          dz11             = iz1 - jz1       
          rsq11            = dx11*dx11+dy11*dy11+dz11*dz11
          fval             = rsq11           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv11           = (0.5*lu*(3.0-((rsq11*lu)*lu)))
          qq               = iq*charge(jnr)  
          tj               = nti+3*type(jnr)+1
          c6               = vdwparam(tj)    
          cexp1            = vdwparam(tj+1)  
          cexp2            = vdwparam(tj+2)  
          rinvsq           = rinv11*rinv11   
          krsq             = krf*rsq11       
          vcoul            = qq*(rinv11+krsq-crf)
          vctot            = vctot+vcoul     
          rinvsix          = rinvsq*rinvsq*rinvsq
          Vvdw6            = c6*rinvsix      
          br               = cexp2*rsq11*rinv11
          Vvdwexp          = cexp1*exp(-br)  
          Vvdwtot          = Vvdwtot+Vvdwexp-Vvdw6
          fscal            = (qq*(rinv11-2.0*krsq)+br*Vvdwexp-6.0
     &  *Vvdw6)*rinvsq
          tx               = fscal*dx11      
          ty               = fscal*dy11      
          tz               = fscal*dz11      
          fix1             = fix1 + tx       
          fiy1             = fiy1 + ty       
          fiz1             = fiz1 + tz       
          faction(j3+0)    = faction(j3+0) - tx
          faction(j3+1)    = faction(j3+1) - ty
          faction(j3+2)    = faction(j3+2) - tz
        end do
        
        faction(ii3+0)   = faction(ii3+0) + fix1
        faction(ii3+1)   = faction(ii3+1) + fiy1
        faction(ii3+2)   = faction(ii3+2) + fiz1
        fshift(is3)      = fshift(is3)+fix1
        fshift(is3+1)    = fshift(is3+1)+fiy1
        fshift(is3+2)    = fshift(is3+2)+fiz1
        ggid             = gid(n)+1        
        Vc(ggid)         = Vc(ggid) + vctot
        Vvdw(ggid)       = Vvdw(ggid) + Vvdwtot
      end do
      
      outeriter        = nri             
      inneriter        = nj1             
      return
      end






C
C Gromacs nonbonded kernel nb_kernel220nf
C Coulomb interaction:     Reaction field
C VdW interaction:         Buckingham
C water optimization:      No
C Calculate forces:        no
C
      subroutine nb_kernel220nf(
     &                          nri,
     &                          iinr,
     &                          jindex,
     &                          jjnr,
     &                          shift,
     &                          shiftvec,
     &                          fshift,
     &                          gid,
     &                          pos,
     &                          faction,
     &                          charge,
     &                          facel,
     &                          krf,
     &                          crf,
     &                          Vc,
     &                          type,
     &                          ntype,
     &                          vdwparam,
     &                          Vvdw,
     &                          tabscale,
     &                          VFtab,
     &                          invsqrta,
     &                          dvda,
     &                          gbtabscale,
     &                          GBtab,
     &                          nthreads,
     &                          count,
     &                          mtx,
     &                          outeriter,
     &                          inneriter,
     &                          work)
      implicit      none
      integer*4     nri,iinr(*),jindex(*),jjnr(*),shift(*)
      real*4        shiftvec(*),fshift(*),pos(*),faction(*)
      integer*4     gid(*),type(*),ntype
      real*4        charge(*),facel,krf,crf,Vc(*),vdwparam(*)
      real*4        Vvdw(*),tabscale,VFtab(*)
      real*4        invsqrta(*),dvda(*),gbtabscale,GBtab(*)
      integer*4     nthreads,count,mtx,outeriter,inneriter
      real*4        work(*)

      integer*4     n,ii,is3,ii3,k,nj0,nj1,jnr,j3,ggid
      real*4        shX,shY,shZ
      real*4        rinvsq
      real*4        iq
      real*4        qq,vcoul,vctot
      integer*4     nti
      integer*4     tj
      real*4        rinvsix
      real*4        Vvdw6,Vvdwtot
      real*4        krsq
      real*4        Vvdwexp,br
      real*4        ix1,iy1,iz1
      real*4        jx1,jy1,jz1
      real*4        dx11,dy11,dz11,rsq11,rinv11
      real*4        c6,cexp1,cexp2
      integer*4     fractshift
          parameter (fractshift = 12)
      integer*4     fractmask
          parameter (fractmask = 8388607)
      integer*4     expshift
          parameter (expshift = 23)
      integer*4     expmask
          parameter (expmask = 2139095040)
      integer*4     explsb
          parameter (explsb = 8388608)
      real*4        lu
      integer*4     iexp,addr
      integer*4     bval,result
      real*4        fval
      equivalence(bval,fval)
      equivalence(result,lu)
      integer*4     invsqrtexptab,invsqrtfracttab
      common /gmxinvsqrtdata/ invsqrtexptab(256),invsqrtfracttab(4096)

      nj1              = 0               
      
      do n=1,nri
        is3              = 3*shift(n)+1    
        shX              = shiftvec(is3)   
        shY              = shiftvec(is3+1) 
        shZ              = shiftvec(is3+2) 
        nj0              = jindex(n)+1     
        nj1              = jindex(n+1)     
        ii               = iinr(n)+1       
        ii3              = 3*ii-2          
        ix1              = shX + pos(ii3+0)
        iy1              = shY + pos(ii3+1)
        iz1              = shZ + pos(ii3+2)
        iq               = facel*charge(ii)
        nti              = 3*ntype*type(ii)
        vctot            = 0               
        Vvdwtot          = 0               
        
        do k=nj0,nj1
          jnr              = jjnr(k)+1       
          j3               = 3*jnr-2         
          jx1              = pos(j3+0)       
          jy1              = pos(j3+1)       
          jz1              = pos(j3+2)       
          dx11             = ix1 - jx1       
          dy11             = iy1 - jy1       
          dz11             = iz1 - jz1       
          rsq11            = dx11*dx11+dy11*dy11+dz11*dz11
          fval             = rsq11           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv11           = (0.5*lu*(3.0-((rsq11*lu)*lu)))
          qq               = iq*charge(jnr)  
          tj               = nti+3*type(jnr)+1
          c6               = vdwparam(tj)    
          cexp1            = vdwparam(tj+1)  
          cexp2            = vdwparam(tj+2)  
          rinvsq           = rinv11*rinv11   
          krsq             = krf*rsq11       
          vcoul            = qq*(rinv11+krsq-crf)
          vctot            = vctot+vcoul     
          rinvsix          = rinvsq*rinvsq*rinvsq
          Vvdw6            = c6*rinvsix      
          br               = cexp2*rsq11*rinv11
          Vvdwexp          = cexp1*exp(-br)  
          Vvdwtot          = Vvdwtot+Vvdwexp-Vvdw6
        end do
        
        ggid             = gid(n)+1        
        Vc(ggid)         = Vc(ggid) + vctot
        Vvdw(ggid)       = Vvdw(ggid) + Vvdwtot
      end do
      
      outeriter        = nri             
      inneriter        = nj1             
      return
      end



