C
C Copyright (c) Erik Lindahl, David van der Spoel 2003
C This file is generated automatically at compile time
C by the program mknb in the Gromacs distribution.
C
C Options used for generating this file:
C Language:         Take a wild guess
C Precision:        single
C Threads:          no
C Software invsqrt: yes
C PowerPC invsqrt:  no
C Prefetch forces:  no
C Comments:         no




C
C Gromacs nonbonded kernel nb_kernel114
C Coulomb interaction:     Normal Coulomb
C VdW interaction:         Lennard-Jones
C water optimization:      pairs of TIP4P interactions
C Calculate forces:        yes
C
      subroutine nb_kernel114(
     &                          nri,
     &                          iinr,
     &                          jindex,
     &                          jjnr,
     &                          shift,
     &                          shiftvec,
     &                          fshift,
     &                          gid,
     &                          pos,
     &                          faction,
     &                          charge,
     &                          facel,
     &                          krf,
     &                          crf,
     &                          Vc,
     &                          type,
     &                          ntype,
     &                          vdwparam,
     &                          Vvdw,
     &                          tabscale,
     &                          VFtab,
     &                          invsqrta,
     &                          dvda,
     &                          gbtabscale,
     &                          GBtab,
     &                          nthreads,
     &                          count,
     &                          mtx,
     &                          outeriter,
     &                          inneriter,
     &                          work)
      implicit      none
      integer*4     nri,iinr(*),jindex(*),jjnr(*),shift(*)
      real*4        shiftvec(*),fshift(*),pos(*),faction(*)
      integer*4     gid(*),type(*),ntype
      real*4        charge(*),facel,krf,crf,Vc(*),vdwparam(*)
      real*4        Vvdw(*),tabscale,VFtab(*)
      real*4        invsqrta(*),dvda(*),gbtabscale,GBtab(*)
      integer*4     nthreads,count,mtx,outeriter,inneriter
      real*4        work(*)

      integer*4     n,ii,is3,ii3,k,nj0,nj1,jnr,j3,ggid
      real*4        shX,shY,shZ
      real*4        fscal,tx,ty,tz
      real*4        rinvsq
      real*4        qq,vcoul,vctot
      integer*4     tj
      real*4        rinvsix
      real*4        Vvdw6,Vvdwtot
      real*4        Vvdw12
      real*4        ix1,iy1,iz1,fix1,fiy1,fiz1
      real*4        ix2,iy2,iz2,fix2,fiy2,fiz2
      real*4        ix3,iy3,iz3,fix3,fiy3,fiz3
      real*4        ix4,iy4,iz4,fix4,fiy4,fiz4
      real*4        jx1,jy1,jz1
      real*4        jx2,jy2,jz2,fjx2,fjy2,fjz2
      real*4        jx3,jy3,jz3,fjx3,fjy3,fjz3
      real*4        jx4,jy4,jz4,fjx4,fjy4,fjz4
      real*4        dx11,dy11,dz11,rsq11
      real*4        dx22,dy22,dz22,rsq22,rinv22
      real*4        dx23,dy23,dz23,rsq23,rinv23
      real*4        dx24,dy24,dz24,rsq24,rinv24
      real*4        dx32,dy32,dz32,rsq32,rinv32
      real*4        dx33,dy33,dz33,rsq33,rinv33
      real*4        dx34,dy34,dz34,rsq34,rinv34
      real*4        dx42,dy42,dz42,rsq42,rinv42
      real*4        dx43,dy43,dz43,rsq43,rinv43
      real*4        dx44,dy44,dz44,rsq44,rinv44
      real*4        qH,qM,qqMM,qqMH,qqHH
      real*4        c6,c12
      integer*4     fractshift
          parameter (fractshift = 12)
      integer*4     fractmask
          parameter (fractmask = 8388607)
      integer*4     expshift
          parameter (expshift = 23)
      integer*4     expmask
          parameter (expmask = 2139095040)
      integer*4     explsb
          parameter (explsb = 8388608)
      real*4        lu
      integer*4     iexp,addr
      integer*4     bval,result
      real*4        fval
      equivalence(bval,fval)
      equivalence(result,lu)
      integer*4     invsqrtexptab,invsqrtfracttab
      common /gmxinvsqrtdata/ invsqrtexptab(256),invsqrtfracttab(4096)

      ii               = iinr(1)+1       
      qH               = charge(ii+1)    
      qM               = charge(ii+3)    
      qqMM             = facel*qM*qM     
      qqMH             = facel*qM*qH     
      qqHH             = facel*qH*qH     
      tj               = 2*(ntype+1)*type(ii)+1
      c6               = vdwparam(tj)    
      c12              = vdwparam(tj+1)  

      nj1              = 0               
      
      do n=1,nri
        is3              = 3*shift(n)+1    
        shX              = shiftvec(is3)   
        shY              = shiftvec(is3+1) 
        shZ              = shiftvec(is3+2) 
        nj0              = jindex(n)+1     
        nj1              = jindex(n+1)     
        ii               = iinr(n)+1       
        ii3              = 3*ii-2          
        ix1              = shX + pos(ii3+0)
        iy1              = shY + pos(ii3+1)
        iz1              = shZ + pos(ii3+2)
        ix2              = shX + pos(ii3+3)
        iy2              = shY + pos(ii3+4)
        iz2              = shZ + pos(ii3+5)
        ix3              = shX + pos(ii3+6)
        iy3              = shY + pos(ii3+7)
        iz3              = shZ + pos(ii3+8)
        ix4              = shX + pos(ii3+9)
        iy4              = shY + pos(ii3+10)
        iz4              = shZ + pos(ii3+11)
        vctot            = 0               
        Vvdwtot          = 0               
        fix1             = 0               
        fiy1             = 0               
        fiz1             = 0               
        fix2             = 0               
        fiy2             = 0               
        fiz2             = 0               
        fix3             = 0               
        fiy3             = 0               
        fiz3             = 0               
        fix4             = 0               
        fiy4             = 0               
        fiz4             = 0               
        
        do k=nj0,nj1
          jnr              = jjnr(k)+1       
          j3               = 3*jnr-2         
          jx1              = pos(j3+0)       
          jy1              = pos(j3+1)       
          jz1              = pos(j3+2)       
          jx2              = pos(j3+3)       
          jy2              = pos(j3+4)       
          jz2              = pos(j3+5)       
          jx3              = pos(j3+6)       
          jy3              = pos(j3+7)       
          jz3              = pos(j3+8)       
          jx4              = pos(j3+9)       
          jy4              = pos(j3+10)      
          jz4              = pos(j3+11)      
          dx11             = ix1 - jx1       
          dy11             = iy1 - jy1       
          dz11             = iz1 - jz1       
          rsq11            = dx11*dx11+dy11*dy11+dz11*dz11
          dx22             = ix2 - jx2       
          dy22             = iy2 - jy2       
          dz22             = iz2 - jz2       
          rsq22            = dx22*dx22+dy22*dy22+dz22*dz22
          dx23             = ix2 - jx3       
          dy23             = iy2 - jy3       
          dz23             = iz2 - jz3       
          rsq23            = dx23*dx23+dy23*dy23+dz23*dz23
          dx24             = ix2 - jx4       
          dy24             = iy2 - jy4       
          dz24             = iz2 - jz4       
          rsq24            = dx24*dx24+dy24*dy24+dz24*dz24
          dx32             = ix3 - jx2       
          dy32             = iy3 - jy2       
          dz32             = iz3 - jz2       
          rsq32            = dx32*dx32+dy32*dy32+dz32*dz32
          dx33             = ix3 - jx3       
          dy33             = iy3 - jy3       
          dz33             = iz3 - jz3       
          rsq33            = dx33*dx33+dy33*dy33+dz33*dz33
          dx34             = ix3 - jx4       
          dy34             = iy3 - jy4       
          dz34             = iz3 - jz4       
          rsq34            = dx34*dx34+dy34*dy34+dz34*dz34
          dx42             = ix4 - jx2       
          dy42             = iy4 - jy2       
          dz42             = iz4 - jz2       
          rsq42            = dx42*dx42+dy42*dy42+dz42*dz42
          dx43             = ix4 - jx3       
          dy43             = iy4 - jy3       
          dz43             = iz4 - jz3       
          rsq43            = dx43*dx43+dy43*dy43+dz43*dz43
          dx44             = ix4 - jx4       
          dy44             = iy4 - jy4       
          dz44             = iz4 - jz4       
          rsq44            = dx44*dx44+dy44*dy44+dz44*dz44
          rinvsq           = 1.0/rsq11       
          fval             = rsq22           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv22           = (0.5*lu*(3.0-((rsq22*lu)*lu)))
          fval             = rsq23           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv23           = (0.5*lu*(3.0-((rsq23*lu)*lu)))
          fval             = rsq24           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv24           = (0.5*lu*(3.0-((rsq24*lu)*lu)))
          fval             = rsq32           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv32           = (0.5*lu*(3.0-((rsq32*lu)*lu)))
          fval             = rsq33           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv33           = (0.5*lu*(3.0-((rsq33*lu)*lu)))
          fval             = rsq34           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv34           = (0.5*lu*(3.0-((rsq34*lu)*lu)))
          fval             = rsq42           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv42           = (0.5*lu*(3.0-((rsq42*lu)*lu)))
          fval             = rsq43           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv43           = (0.5*lu*(3.0-((rsq43*lu)*lu)))
          fval             = rsq44           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv44           = (0.5*lu*(3.0-((rsq44*lu)*lu)))
          rinvsix          = rinvsq*rinvsq*rinvsq
          Vvdw6            = c6*rinvsix      
          Vvdw12           = c12*rinvsix*rinvsix
          Vvdwtot          = Vvdwtot+Vvdw12-Vvdw6
          fscal            = (12.0*Vvdw12-6.0*Vvdw6)*rinvsq
          tx               = fscal*dx11      
          ty               = fscal*dy11      
          tz               = fscal*dz11      
          fix1             = fix1 + tx       
          fiy1             = fiy1 + ty       
          fiz1             = fiz1 + tz       
          faction(j3+0)    = faction(j3+0) - tx
          faction(j3+1)    = faction(j3+1) - ty
          faction(j3+2)    = faction(j3+2) - tz
          qq               = qqHH            
          rinvsq           = rinv22*rinv22   
          vcoul            = qq*rinv22       
          vctot            = vctot+vcoul     
          fscal            = (vcoul)*rinvsq  
          tx               = fscal*dx22      
          ty               = fscal*dy22      
          tz               = fscal*dz22      
          fix2             = fix2 + tx       
          fiy2             = fiy2 + ty       
          fiz2             = fiz2 + tz       
          fjx2             = faction(j3+3) - tx
          fjy2             = faction(j3+4) - ty
          fjz2             = faction(j3+5) - tz
          qq               = qqHH            
          rinvsq           = rinv23*rinv23   
          vcoul            = qq*rinv23       
          vctot            = vctot+vcoul     
          fscal            = (vcoul)*rinvsq  
          tx               = fscal*dx23      
          ty               = fscal*dy23      
          tz               = fscal*dz23      
          fix2             = fix2 + tx       
          fiy2             = fiy2 + ty       
          fiz2             = fiz2 + tz       
          fjx3             = faction(j3+6) - tx
          fjy3             = faction(j3+7) - ty
          fjz3             = faction(j3+8) - tz
          qq               = qqMH            
          rinvsq           = rinv24*rinv24   
          vcoul            = qq*rinv24       
          vctot            = vctot+vcoul     
          fscal            = (vcoul)*rinvsq  
          tx               = fscal*dx24      
          ty               = fscal*dy24      
          tz               = fscal*dz24      
          fix2             = fix2 + tx       
          fiy2             = fiy2 + ty       
          fiz2             = fiz2 + tz       
          fjx4             = faction(j3+9) - tx
          fjy4             = faction(j3+10) - ty
          fjz4             = faction(j3+11) - tz
          qq               = qqHH            
          rinvsq           = rinv32*rinv32   
          vcoul            = qq*rinv32       
          vctot            = vctot+vcoul     
          fscal            = (vcoul)*rinvsq  
          tx               = fscal*dx32      
          ty               = fscal*dy32      
          tz               = fscal*dz32      
          fix3             = fix3 + tx       
          fiy3             = fiy3 + ty       
          fiz3             = fiz3 + tz       
          fjx2             = fjx2 - tx       
          fjy2             = fjy2 - ty       
          fjz2             = fjz2 - tz       
          qq               = qqHH            
          rinvsq           = rinv33*rinv33   
          vcoul            = qq*rinv33       
          vctot            = vctot+vcoul     
          fscal            = (vcoul)*rinvsq  
          tx               = fscal*dx33      
          ty               = fscal*dy33      
          tz               = fscal*dz33      
          fix3             = fix3 + tx       
          fiy3             = fiy3 + ty       
          fiz3             = fiz3 + tz       
          fjx3             = fjx3 - tx       
          fjy3             = fjy3 - ty       
          fjz3             = fjz3 - tz       
          qq               = qqMH            
          rinvsq           = rinv34*rinv34   
          vcoul            = qq*rinv34       
          vctot            = vctot+vcoul     
          fscal            = (vcoul)*rinvsq  
          tx               = fscal*dx34      
          ty               = fscal*dy34      
          tz               = fscal*dz34      
          fix3             = fix3 + tx       
          fiy3             = fiy3 + ty       
          fiz3             = fiz3 + tz       
          fjx4             = fjx4 - tx       
          fjy4             = fjy4 - ty       
          fjz4             = fjz4 - tz       
          qq               = qqMH            
          rinvsq           = rinv42*rinv42   
          vcoul            = qq*rinv42       
          vctot            = vctot+vcoul     
          fscal            = (vcoul)*rinvsq  
          tx               = fscal*dx42      
          ty               = fscal*dy42      
          tz               = fscal*dz42      
          fix4             = fix4 + tx       
          fiy4             = fiy4 + ty       
          fiz4             = fiz4 + tz       
          faction(j3+3)    = fjx2 - tx       
          faction(j3+4)    = fjy2 - ty       
          faction(j3+5)    = fjz2 - tz       
          qq               = qqMH            
          rinvsq           = rinv43*rinv43   
          vcoul            = qq*rinv43       
          vctot            = vctot+vcoul     
          fscal            = (vcoul)*rinvsq  
          tx               = fscal*dx43      
          ty               = fscal*dy43      
          tz               = fscal*dz43      
          fix4             = fix4 + tx       
          fiy4             = fiy4 + ty       
          fiz4             = fiz4 + tz       
          faction(j3+6)    = fjx3 - tx       
          faction(j3+7)    = fjy3 - ty       
          faction(j3+8)    = fjz3 - tz       
          qq               = qqMM            
          rinvsq           = rinv44*rinv44   
          vcoul            = qq*rinv44       
          vctot            = vctot+vcoul     
          fscal            = (vcoul)*rinvsq  
          tx               = fscal*dx44      
          ty               = fscal*dy44      
          tz               = fscal*dz44      
          fix4             = fix4 + tx       
          fiy4             = fiy4 + ty       
          fiz4             = fiz4 + tz       
          faction(j3+9)    = fjx4 - tx       
          faction(j3+10)   = fjy4 - ty       
          faction(j3+11)   = fjz4 - tz       
        end do
        
        faction(ii3+0)   = faction(ii3+0) + fix1
        faction(ii3+1)   = faction(ii3+1) + fiy1
        faction(ii3+2)   = faction(ii3+2) + fiz1
        faction(ii3+3)   = faction(ii3+3) + fix2
        faction(ii3+4)   = faction(ii3+4) + fiy2
        faction(ii3+5)   = faction(ii3+5) + fiz2
        faction(ii3+6)   = faction(ii3+6) + fix3
        faction(ii3+7)   = faction(ii3+7) + fiy3
        faction(ii3+8)   = faction(ii3+8) + fiz3
        faction(ii3+9)   = faction(ii3+9) + fix4
        faction(ii3+10)  = faction(ii3+10) + fiy4
        faction(ii3+11)  = faction(ii3+11) + fiz4
        fshift(is3)      = fshift(is3)+fix1+fix2+fix3+fix4
        fshift(is3+1)    = fshift(is3+1)+fiy1+fiy2+fiy3+fiy4
        fshift(is3+2)    = fshift(is3+2)+fiz1+fiz2+fiz3+fiz4
        ggid             = gid(n)+1        
        Vc(ggid)         = Vc(ggid) + vctot
        Vvdw(ggid)       = Vvdw(ggid) + Vvdwtot
      end do
      
      outeriter        = nri             
      inneriter        = nj1             
      return
      end






C
C Gromacs nonbonded kernel nb_kernel114nf
C Coulomb interaction:     Normal Coulomb
C VdW interaction:         Lennard-Jones
C water optimization:      pairs of TIP4P interactions
C Calculate forces:        no
C
      subroutine nb_kernel114nf(
     &                          nri,
     &                          iinr,
     &                          jindex,
     &                          jjnr,
     &                          shift,
     &                          shiftvec,
     &                          fshift,
     &                          gid,
     &                          pos,
     &                          faction,
     &                          charge,
     &                          facel,
     &                          krf,
     &                          crf,
     &                          Vc,
     &                          type,
     &                          ntype,
     &                          vdwparam,
     &                          Vvdw,
     &                          tabscale,
     &                          VFtab,
     &                          invsqrta,
     &                          dvda,
     &                          gbtabscale,
     &                          GBtab,
     &                          nthreads,
     &                          count,
     &                          mtx,
     &                          outeriter,
     &                          inneriter,
     &                          work)
      implicit      none
      integer*4     nri,iinr(*),jindex(*),jjnr(*),shift(*)
      real*4        shiftvec(*),fshift(*),pos(*),faction(*)
      integer*4     gid(*),type(*),ntype
      real*4        charge(*),facel,krf,crf,Vc(*),vdwparam(*)
      real*4        Vvdw(*),tabscale,VFtab(*)
      real*4        invsqrta(*),dvda(*),gbtabscale,GBtab(*)
      integer*4     nthreads,count,mtx,outeriter,inneriter
      real*4        work(*)

      integer*4     n,ii,is3,ii3,k,nj0,nj1,jnr,j3,ggid
      real*4        shX,shY,shZ
      real*4        rinvsq
      real*4        qq,vcoul,vctot
      integer*4     tj
      real*4        rinvsix
      real*4        Vvdw6,Vvdwtot
      real*4        Vvdw12
      real*4        ix1,iy1,iz1
      real*4        ix2,iy2,iz2
      real*4        ix3,iy3,iz3
      real*4        ix4,iy4,iz4
      real*4        jx1,jy1,jz1
      real*4        jx2,jy2,jz2
      real*4        jx3,jy3,jz3
      real*4        jx4,jy4,jz4
      real*4        dx11,dy11,dz11,rsq11
      real*4        dx22,dy22,dz22,rsq22,rinv22
      real*4        dx23,dy23,dz23,rsq23,rinv23
      real*4        dx24,dy24,dz24,rsq24,rinv24
      real*4        dx32,dy32,dz32,rsq32,rinv32
      real*4        dx33,dy33,dz33,rsq33,rinv33
      real*4        dx34,dy34,dz34,rsq34,rinv34
      real*4        dx42,dy42,dz42,rsq42,rinv42
      real*4        dx43,dy43,dz43,rsq43,rinv43
      real*4        dx44,dy44,dz44,rsq44,rinv44
      real*4        qH,qM,qqMM,qqMH,qqHH
      real*4        c6,c12
      integer*4     fractshift
          parameter (fractshift = 12)
      integer*4     fractmask
          parameter (fractmask = 8388607)
      integer*4     expshift
          parameter (expshift = 23)
      integer*4     expmask
          parameter (expmask = 2139095040)
      integer*4     explsb
          parameter (explsb = 8388608)
      real*4        lu
      integer*4     iexp,addr
      integer*4     bval,result
      real*4        fval
      equivalence(bval,fval)
      equivalence(result,lu)
      integer*4     invsqrtexptab,invsqrtfracttab
      common /gmxinvsqrtdata/ invsqrtexptab(256),invsqrtfracttab(4096)

      ii               = iinr(1)+1       
      qH               = charge(ii+1)    
      qM               = charge(ii+3)    
      qqMM             = facel*qM*qM     
      qqMH             = facel*qM*qH     
      qqHH             = facel*qH*qH     
      tj               = 2*(ntype+1)*type(ii)+1
      c6               = vdwparam(tj)    
      c12              = vdwparam(tj+1)  

      nj1              = 0               
      
      do n=1,nri
        is3              = 3*shift(n)+1    
        shX              = shiftvec(is3)   
        shY              = shiftvec(is3+1) 
        shZ              = shiftvec(is3+2) 
        nj0              = jindex(n)+1     
        nj1              = jindex(n+1)     
        ii               = iinr(n)+1       
        ii3              = 3*ii-2          
        ix1              = shX + pos(ii3+0)
        iy1              = shY + pos(ii3+1)
        iz1              = shZ + pos(ii3+2)
        ix2              = shX + pos(ii3+3)
        iy2              = shY + pos(ii3+4)
        iz2              = shZ + pos(ii3+5)
        ix3              = shX + pos(ii3+6)
        iy3              = shY + pos(ii3+7)
        iz3              = shZ + pos(ii3+8)
        ix4              = shX + pos(ii3+9)
        iy4              = shY + pos(ii3+10)
        iz4              = shZ + pos(ii3+11)
        vctot            = 0               
        Vvdwtot          = 0               
        
        do k=nj0,nj1
          jnr              = jjnr(k)+1       
          j3               = 3*jnr-2         
          jx1              = pos(j3+0)       
          jy1              = pos(j3+1)       
          jz1              = pos(j3+2)       
          jx2              = pos(j3+3)       
          jy2              = pos(j3+4)       
          jz2              = pos(j3+5)       
          jx3              = pos(j3+6)       
          jy3              = pos(j3+7)       
          jz3              = pos(j3+8)       
          jx4              = pos(j3+9)       
          jy4              = pos(j3+10)      
          jz4              = pos(j3+11)      
          dx11             = ix1 - jx1       
          dy11             = iy1 - jy1       
          dz11             = iz1 - jz1       
          rsq11            = dx11*dx11+dy11*dy11+dz11*dz11
          dx22             = ix2 - jx2       
          dy22             = iy2 - jy2       
          dz22             = iz2 - jz2       
          rsq22            = dx22*dx22+dy22*dy22+dz22*dz22
          dx23             = ix2 - jx3       
          dy23             = iy2 - jy3       
          dz23             = iz2 - jz3       
          rsq23            = dx23*dx23+dy23*dy23+dz23*dz23
          dx24             = ix2 - jx4       
          dy24             = iy2 - jy4       
          dz24             = iz2 - jz4       
          rsq24            = dx24*dx24+dy24*dy24+dz24*dz24
          dx32             = ix3 - jx2       
          dy32             = iy3 - jy2       
          dz32             = iz3 - jz2       
          rsq32            = dx32*dx32+dy32*dy32+dz32*dz32
          dx33             = ix3 - jx3       
          dy33             = iy3 - jy3       
          dz33             = iz3 - jz3       
          rsq33            = dx33*dx33+dy33*dy33+dz33*dz33
          dx34             = ix3 - jx4       
          dy34             = iy3 - jy4       
          dz34             = iz3 - jz4       
          rsq34            = dx34*dx34+dy34*dy34+dz34*dz34
          dx42             = ix4 - jx2       
          dy42             = iy4 - jy2       
          dz42             = iz4 - jz2       
          rsq42            = dx42*dx42+dy42*dy42+dz42*dz42
          dx43             = ix4 - jx3       
          dy43             = iy4 - jy3       
          dz43             = iz4 - jz3       
          rsq43            = dx43*dx43+dy43*dy43+dz43*dz43
          dx44             = ix4 - jx4       
          dy44             = iy4 - jy4       
          dz44             = iz4 - jz4       
          rsq44            = dx44*dx44+dy44*dy44+dz44*dz44
          rinvsq           = 1.0/rsq11       
          fval             = rsq22           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv22           = (0.5*lu*(3.0-((rsq22*lu)*lu)))
          fval             = rsq23           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv23           = (0.5*lu*(3.0-((rsq23*lu)*lu)))
          fval             = rsq24           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv24           = (0.5*lu*(3.0-((rsq24*lu)*lu)))
          fval             = rsq32           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv32           = (0.5*lu*(3.0-((rsq32*lu)*lu)))
          fval             = rsq33           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv33           = (0.5*lu*(3.0-((rsq33*lu)*lu)))
          fval             = rsq34           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv34           = (0.5*lu*(3.0-((rsq34*lu)*lu)))
          fval             = rsq42           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv42           = (0.5*lu*(3.0-((rsq42*lu)*lu)))
          fval             = rsq43           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv43           = (0.5*lu*(3.0-((rsq43*lu)*lu)))
          fval             = rsq44           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv44           = (0.5*lu*(3.0-((rsq44*lu)*lu)))
          rinvsix          = rinvsq*rinvsq*rinvsq
          Vvdw6            = c6*rinvsix      
          Vvdw12           = c12*rinvsix*rinvsix
          Vvdwtot          = Vvdwtot+Vvdw12-Vvdw6
          qq               = qqHH            
          vcoul            = qq*rinv22       
          vctot            = vctot+vcoul     
          qq               = qqHH            
          vcoul            = qq*rinv23       
          vctot            = vctot+vcoul     
          qq               = qqMH            
          vcoul            = qq*rinv24       
          vctot            = vctot+vcoul     
          qq               = qqHH            
          vcoul            = qq*rinv32       
          vctot            = vctot+vcoul     
          qq               = qqHH            
          vcoul            = qq*rinv33       
          vctot            = vctot+vcoul     
          qq               = qqMH            
          vcoul            = qq*rinv34       
          vctot            = vctot+vcoul     
          qq               = qqMH            
          vcoul            = qq*rinv42       
          vctot            = vctot+vcoul     
          qq               = qqMH            
          vcoul            = qq*rinv43       
          vctot            = vctot+vcoul     
          qq               = qqMM            
          vcoul            = qq*rinv44       
          vctot            = vctot+vcoul     
        end do
        
        ggid             = gid(n)+1        
        Vc(ggid)         = Vc(ggid) + vctot
        Vvdw(ggid)       = Vvdw(ggid) + Vvdwtot
      end do
      
      outeriter        = nri             
      inneriter        = nj1             
      return
      end



