C
C Copyright (c) Erik Lindahl, David van der Spoel 2003
C This file is generated automatically at compile time
C by the program mknb in the Gromacs distribution.
C
C Options used for generating this file:
C Language:         Take a wild guess
C Precision:        single
C Threads:          no
C Software invsqrt: yes
C PowerPC invsqrt:  no
C Prefetch forces:  no
C Comments:         no




C
C Gromacs nonbonded kernel nb_kernel333
C Coulomb interaction:     Tabulated
C VdW interaction:         Tabulated
C water optimization:      TIP4P - other atoms
C Calculate forces:        yes
C
      subroutine nb_kernel333(
     &                          nri,
     &                          iinr,
     &                          jindex,
     &                          jjnr,
     &                          shift,
     &                          shiftvec,
     &                          fshift,
     &                          gid,
     &                          pos,
     &                          faction,
     &                          charge,
     &                          facel,
     &                          krf,
     &                          crf,
     &                          Vc,
     &                          type,
     &                          ntype,
     &                          vdwparam,
     &                          Vvdw,
     &                          tabscale,
     &                          VFtab,
     &                          invsqrta,
     &                          dvda,
     &                          gbtabscale,
     &                          GBtab,
     &                          nthreads,
     &                          count,
     &                          mtx,
     &                          outeriter,
     &                          inneriter,
     &                          work)
      implicit      none
      integer*4     nri,iinr(*),jindex(*),jjnr(*),shift(*)
      real*4        shiftvec(*),fshift(*),pos(*),faction(*)
      integer*4     gid(*),type(*),ntype
      real*4        charge(*),facel,krf,crf,Vc(*),vdwparam(*)
      real*4        Vvdw(*),tabscale,VFtab(*)
      real*4        invsqrta(*),dvda(*),gbtabscale,GBtab(*)
      integer*4     nthreads,count,mtx,outeriter,inneriter
      real*4        work(*)

      integer*4     n,ii,is3,ii3,k,nj0,nj1,jnr,j3,ggid
      real*4        shX,shY,shZ
      real*4        fscal,tx,ty,tz
      real*4        jq
      real*4        qq,vcoul,vctot
      integer*4     nti
      integer*4     tj
      real*4        Vvdw6,Vvdwtot
      real*4        Vvdw12
      real*4        r,rt,eps,eps2
      integer*4     n0,nnn
      real*4        Y,F,Geps,Heps2,Fp,VV
      real*4        FF
      real*4        fijC
      real*4        fijD,fijR
      real*4        ix1,iy1,iz1,fix1,fiy1,fiz1
      real*4        ix2,iy2,iz2,fix2,fiy2,fiz2
      real*4        ix3,iy3,iz3,fix3,fiy3,fiz3
      real*4        ix4,iy4,iz4,fix4,fiy4,fiz4
      real*4        jx1,jy1,jz1,fjx1,fjy1,fjz1
      real*4        dx11,dy11,dz11,rsq11,rinv11
      real*4        dx21,dy21,dz21,rsq21,rinv21
      real*4        dx31,dy31,dz31,rsq31,rinv31
      real*4        dx41,dy41,dz41,rsq41,rinv41
      real*4        qH,qM
      real*4        c6,c12
      integer*4     fractshift
          parameter (fractshift = 12)
      integer*4     fractmask
          parameter (fractmask = 8388607)
      integer*4     expshift
          parameter (expshift = 23)
      integer*4     expmask
          parameter (expmask = 2139095040)
      integer*4     explsb
          parameter (explsb = 8388608)
      real*4        lu
      integer*4     iexp,addr
      integer*4     bval,result
      real*4        fval
      equivalence(bval,fval)
      equivalence(result,lu)
      integer*4     invsqrtexptab,invsqrtfracttab
      common /gmxinvsqrtdata/ invsqrtexptab(256),invsqrtfracttab(4096)

      ii               = iinr(1)+1       
      qH               = facel*charge(ii+1)
      qM               = facel*charge(ii+3)
      nti              = 2*ntype*type(ii)

      nj1              = 0               
      
      do n=1,nri
        is3              = 3*shift(n)+1    
        shX              = shiftvec(is3)   
        shY              = shiftvec(is3+1) 
        shZ              = shiftvec(is3+2) 
        nj0              = jindex(n)+1     
        nj1              = jindex(n+1)     
        ii               = iinr(n)+1       
        ii3              = 3*ii-2          
        ix1              = shX + pos(ii3+0)
        iy1              = shY + pos(ii3+1)
        iz1              = shZ + pos(ii3+2)
        ix2              = shX + pos(ii3+3)
        iy2              = shY + pos(ii3+4)
        iz2              = shZ + pos(ii3+5)
        ix3              = shX + pos(ii3+6)
        iy3              = shY + pos(ii3+7)
        iz3              = shZ + pos(ii3+8)
        ix4              = shX + pos(ii3+9)
        iy4              = shY + pos(ii3+10)
        iz4              = shZ + pos(ii3+11)
        vctot            = 0               
        Vvdwtot          = 0               
        fix1             = 0               
        fiy1             = 0               
        fiz1             = 0               
        fix2             = 0               
        fiy2             = 0               
        fiz2             = 0               
        fix3             = 0               
        fiy3             = 0               
        fiz3             = 0               
        fix4             = 0               
        fiy4             = 0               
        fiz4             = 0               
        
        do k=nj0,nj1
          jnr              = jjnr(k)+1       
          j3               = 3*jnr-2         
          jx1              = pos(j3+0)       
          jy1              = pos(j3+1)       
          jz1              = pos(j3+2)       
          dx11             = ix1 - jx1       
          dy11             = iy1 - jy1       
          dz11             = iz1 - jz1       
          rsq11            = dx11*dx11+dy11*dy11+dz11*dz11
          dx21             = ix2 - jx1       
          dy21             = iy2 - jy1       
          dz21             = iz2 - jz1       
          rsq21            = dx21*dx21+dy21*dy21+dz21*dz21
          dx31             = ix3 - jx1       
          dy31             = iy3 - jy1       
          dz31             = iz3 - jz1       
          rsq31            = dx31*dx31+dy31*dy31+dz31*dz31
          dx41             = ix4 - jx1       
          dy41             = iy4 - jy1       
          dz41             = iz4 - jz1       
          rsq41            = dx41*dx41+dy41*dy41+dz41*dz41
          fval             = rsq11           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv11           = (0.5*lu*(3.0-((rsq11*lu)*lu)))
          fval             = rsq21           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv21           = (0.5*lu*(3.0-((rsq21*lu)*lu)))
          fval             = rsq31           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv31           = (0.5*lu*(3.0-((rsq31*lu)*lu)))
          fval             = rsq41           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv41           = (0.5*lu*(3.0-((rsq41*lu)*lu)))
          tj               = nti+2*type(jnr)+1
          c6               = vdwparam(tj)    
          c12              = vdwparam(tj+1)  
          r                = rsq11*rinv11    
          rt               = r*tabscale      
          n0               = rt              
          eps              = rt-n0           
          eps2             = eps*eps         
          nnn              = 12*n0+1         
          nnn              = nnn+4           
          Y                = VFtab(nnn)      
          F                = VFtab(nnn+1)    
          Geps             = eps*VFtab(nnn+2)
          Heps2            = eps2*VFtab(nnn+3)
          Fp               = F+Geps+Heps2    
          VV               = Y+eps*Fp        
          FF               = Fp+Geps+2.0*Heps2
          Vvdw6            = c6*VV           
          fijD             = c6*FF           
          nnn              = nnn+4           
          Y                = VFtab(nnn)      
          F                = VFtab(nnn+1)    
          Geps             = eps*VFtab(nnn+2)
          Heps2            = eps2*VFtab(nnn+3)
          Fp               = F+Geps+Heps2    
          VV               = Y+eps*Fp        
          FF               = Fp+Geps+2.0*Heps2
          Vvdw12           = c12*VV          
          fijR             = c12*FF          
          Vvdwtot          = Vvdwtot+ Vvdw6 + Vvdw12
          fscal            = -((fijD+fijR)*tabscale)*rinv11
          tx               = fscal*dx11      
          ty               = fscal*dy11      
          tz               = fscal*dz11      
          fix1             = fix1 + tx       
          fiy1             = fiy1 + ty       
          fiz1             = fiz1 + tz       
          fjx1             = faction(j3+0) - tx
          fjy1             = faction(j3+1) - ty
          fjz1             = faction(j3+2) - tz
          jq               = charge(jnr+0)   
          qq               = qH*jq           
          r                = rsq21*rinv21    
          rt               = r*tabscale      
          n0               = rt              
          eps              = rt-n0           
          eps2             = eps*eps         
          nnn              = 12*n0+1         
          Y                = VFtab(nnn)      
          F                = VFtab(nnn+1)    
          Geps             = eps*VFtab(nnn+2)
          Heps2            = eps2*VFtab(nnn+3)
          Fp               = F+Geps+Heps2    
          VV               = Y+eps*Fp        
          FF               = Fp+Geps+2.0*Heps2
          vcoul            = qq*VV           
          fijC             = qq*FF           
          vctot            = vctot + vcoul   
          fscal            = -((fijC)*tabscale)*rinv21
          tx               = fscal*dx21      
          ty               = fscal*dy21      
          tz               = fscal*dz21      
          fix2             = fix2 + tx       
          fiy2             = fiy2 + ty       
          fiz2             = fiz2 + tz       
          fjx1             = fjx1 - tx       
          fjy1             = fjy1 - ty       
          fjz1             = fjz1 - tz       
          r                = rsq31*rinv31    
          rt               = r*tabscale      
          n0               = rt              
          eps              = rt-n0           
          eps2             = eps*eps         
          nnn              = 12*n0+1         
          Y                = VFtab(nnn)      
          F                = VFtab(nnn+1)    
          Geps             = eps*VFtab(nnn+2)
          Heps2            = eps2*VFtab(nnn+3)
          Fp               = F+Geps+Heps2    
          VV               = Y+eps*Fp        
          FF               = Fp+Geps+2.0*Heps2
          vcoul            = qq*VV           
          fijC             = qq*FF           
          vctot            = vctot + vcoul   
          fscal            = -((fijC)*tabscale)*rinv31
          tx               = fscal*dx31      
          ty               = fscal*dy31      
          tz               = fscal*dz31      
          fix3             = fix3 + tx       
          fiy3             = fiy3 + ty       
          fiz3             = fiz3 + tz       
          fjx1             = fjx1 - tx       
          fjy1             = fjy1 - ty       
          fjz1             = fjz1 - tz       
          qq               = qM*jq           
          r                = rsq41*rinv41    
          rt               = r*tabscale      
          n0               = rt              
          eps              = rt-n0           
          eps2             = eps*eps         
          nnn              = 12*n0+1         
          Y                = VFtab(nnn)      
          F                = VFtab(nnn+1)    
          Geps             = eps*VFtab(nnn+2)
          Heps2            = eps2*VFtab(nnn+3)
          Fp               = F+Geps+Heps2    
          VV               = Y+eps*Fp        
          FF               = Fp+Geps+2.0*Heps2
          vcoul            = qq*VV           
          fijC             = qq*FF           
          vctot            = vctot + vcoul   
          fscal            = -((fijC)*tabscale)*rinv41
          tx               = fscal*dx41      
          ty               = fscal*dy41      
          tz               = fscal*dz41      
          fix4             = fix4 + tx       
          fiy4             = fiy4 + ty       
          fiz4             = fiz4 + tz       
          faction(j3+0)    = fjx1 - tx       
          faction(j3+1)    = fjy1 - ty       
          faction(j3+2)    = fjz1 - tz       
        end do
        
        faction(ii3+0)   = faction(ii3+0) + fix1
        faction(ii3+1)   = faction(ii3+1) + fiy1
        faction(ii3+2)   = faction(ii3+2) + fiz1
        faction(ii3+3)   = faction(ii3+3) + fix2
        faction(ii3+4)   = faction(ii3+4) + fiy2
        faction(ii3+5)   = faction(ii3+5) + fiz2
        faction(ii3+6)   = faction(ii3+6) + fix3
        faction(ii3+7)   = faction(ii3+7) + fiy3
        faction(ii3+8)   = faction(ii3+8) + fiz3
        faction(ii3+9)   = faction(ii3+9) + fix4
        faction(ii3+10)  = faction(ii3+10) + fiy4
        faction(ii3+11)  = faction(ii3+11) + fiz4
        fshift(is3)      = fshift(is3)+fix1+fix2+fix3+fix4
        fshift(is3+1)    = fshift(is3+1)+fiy1+fiy2+fiy3+fiy4
        fshift(is3+2)    = fshift(is3+2)+fiz1+fiz2+fiz3+fiz4
        ggid             = gid(n)+1        
        Vc(ggid)         = Vc(ggid) + vctot
        Vvdw(ggid)       = Vvdw(ggid) + Vvdwtot
      end do
      
      outeriter        = nri             
      inneriter        = nj1             
      return
      end






C
C Gromacs nonbonded kernel nb_kernel333nf
C Coulomb interaction:     Tabulated
C VdW interaction:         Tabulated
C water optimization:      TIP4P - other atoms
C Calculate forces:        no
C
      subroutine nb_kernel333nf(
     &                          nri,
     &                          iinr,
     &                          jindex,
     &                          jjnr,
     &                          shift,
     &                          shiftvec,
     &                          fshift,
     &                          gid,
     &                          pos,
     &                          faction,
     &                          charge,
     &                          facel,
     &                          krf,
     &                          crf,
     &                          Vc,
     &                          type,
     &                          ntype,
     &                          vdwparam,
     &                          Vvdw,
     &                          tabscale,
     &                          VFtab,
     &                          invsqrta,
     &                          dvda,
     &                          gbtabscale,
     &                          GBtab,
     &                          nthreads,
     &                          count,
     &                          mtx,
     &                          outeriter,
     &                          inneriter,
     &                          work)
      implicit      none
      integer*4     nri,iinr(*),jindex(*),jjnr(*),shift(*)
      real*4        shiftvec(*),fshift(*),pos(*),faction(*)
      integer*4     gid(*),type(*),ntype
      real*4        charge(*),facel,krf,crf,Vc(*),vdwparam(*)
      real*4        Vvdw(*),tabscale,VFtab(*)
      real*4        invsqrta(*),dvda(*),gbtabscale,GBtab(*)
      integer*4     nthreads,count,mtx,outeriter,inneriter
      real*4        work(*)

      integer*4     n,ii,is3,ii3,k,nj0,nj1,jnr,j3,ggid
      real*4        shX,shY,shZ
      real*4        jq
      real*4        qq,vcoul,vctot
      integer*4     nti
      integer*4     tj
      real*4        Vvdw6,Vvdwtot
      real*4        Vvdw12
      real*4        r,rt,eps,eps2
      integer*4     n0,nnn
      real*4        Y,F,Geps,Heps2,Fp,VV
      real*4        ix1,iy1,iz1
      real*4        ix2,iy2,iz2
      real*4        ix3,iy3,iz3
      real*4        ix4,iy4,iz4
      real*4        jx1,jy1,jz1
      real*4        dx11,dy11,dz11,rsq11,rinv11
      real*4        dx21,dy21,dz21,rsq21,rinv21
      real*4        dx31,dy31,dz31,rsq31,rinv31
      real*4        dx41,dy41,dz41,rsq41,rinv41
      real*4        qH,qM
      real*4        c6,c12
      integer*4     fractshift
          parameter (fractshift = 12)
      integer*4     fractmask
          parameter (fractmask = 8388607)
      integer*4     expshift
          parameter (expshift = 23)
      integer*4     expmask
          parameter (expmask = 2139095040)
      integer*4     explsb
          parameter (explsb = 8388608)
      real*4        lu
      integer*4     iexp,addr
      integer*4     bval,result
      real*4        fval
      equivalence(bval,fval)
      equivalence(result,lu)
      integer*4     invsqrtexptab,invsqrtfracttab
      common /gmxinvsqrtdata/ invsqrtexptab(256),invsqrtfracttab(4096)

      ii               = iinr(1)+1       
      qH               = facel*charge(ii+1)
      qM               = facel*charge(ii+3)
      nti              = 2*ntype*type(ii)

      nj1              = 0               
      
      do n=1,nri
        is3              = 3*shift(n)+1    
        shX              = shiftvec(is3)   
        shY              = shiftvec(is3+1) 
        shZ              = shiftvec(is3+2) 
        nj0              = jindex(n)+1     
        nj1              = jindex(n+1)     
        ii               = iinr(n)+1       
        ii3              = 3*ii-2          
        ix1              = shX + pos(ii3+0)
        iy1              = shY + pos(ii3+1)
        iz1              = shZ + pos(ii3+2)
        ix2              = shX + pos(ii3+3)
        iy2              = shY + pos(ii3+4)
        iz2              = shZ + pos(ii3+5)
        ix3              = shX + pos(ii3+6)
        iy3              = shY + pos(ii3+7)
        iz3              = shZ + pos(ii3+8)
        ix4              = shX + pos(ii3+9)
        iy4              = shY + pos(ii3+10)
        iz4              = shZ + pos(ii3+11)
        vctot            = 0               
        Vvdwtot          = 0               
        
        do k=nj0,nj1
          jnr              = jjnr(k)+1       
          j3               = 3*jnr-2         
          jx1              = pos(j3+0)       
          jy1              = pos(j3+1)       
          jz1              = pos(j3+2)       
          dx11             = ix1 - jx1       
          dy11             = iy1 - jy1       
          dz11             = iz1 - jz1       
          rsq11            = dx11*dx11+dy11*dy11+dz11*dz11
          dx21             = ix2 - jx1       
          dy21             = iy2 - jy1       
          dz21             = iz2 - jz1       
          rsq21            = dx21*dx21+dy21*dy21+dz21*dz21
          dx31             = ix3 - jx1       
          dy31             = iy3 - jy1       
          dz31             = iz3 - jz1       
          rsq31            = dx31*dx31+dy31*dy31+dz31*dz31
          dx41             = ix4 - jx1       
          dy41             = iy4 - jy1       
          dz41             = iz4 - jz1       
          rsq41            = dx41*dx41+dy41*dy41+dz41*dz41
          fval             = rsq11           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv11           = (0.5*lu*(3.0-((rsq11*lu)*lu)))
          fval             = rsq21           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv21           = (0.5*lu*(3.0-((rsq21*lu)*lu)))
          fval             = rsq31           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv31           = (0.5*lu*(3.0-((rsq31*lu)*lu)))
          fval             = rsq41           
          iexp             = rshift(and(bval,expmask),expshift)
          addr             =
     &   rshift(and(bval,or(fractmask,explsb)),fractshift)
          result           = or(invsqrtexptab(iexp
     &  +1),invsqrtfracttab(addr+1))
          rinv41           = (0.5*lu*(3.0-((rsq41*lu)*lu)))
          tj               = nti+2*type(jnr)+1
          c6               = vdwparam(tj)    
          c12              = vdwparam(tj+1)  
          r                = rsq11*rinv11    
          rt               = r*tabscale      
          n0               = rt              
          eps              = rt-n0           
          eps2             = eps*eps         
          nnn              = 12*n0+1         
          nnn              = nnn+4           
          Y                = VFtab(nnn)      
          F                = VFtab(nnn+1)    
          Geps             = eps*VFtab(nnn+2)
          Heps2            = eps2*VFtab(nnn+3)
          Fp               = F+Geps+Heps2    
          VV               = Y+eps*Fp        
          Vvdw6            = c6*VV           
          nnn              = nnn+4           
          Y                = VFtab(nnn)      
          F                = VFtab(nnn+1)    
          Geps             = eps*VFtab(nnn+2)
          Heps2            = eps2*VFtab(nnn+3)
          Fp               = F+Geps+Heps2    
          VV               = Y+eps*Fp        
          Vvdw12           = c12*VV          
          Vvdwtot          = Vvdwtot+ Vvdw6 + Vvdw12
          jq               = charge(jnr+0)   
          qq               = qH*jq           
          r                = rsq21*rinv21    
          rt               = r*tabscale      
          n0               = rt              
          eps              = rt-n0           
          eps2             = eps*eps         
          nnn              = 12*n0+1         
          Y                = VFtab(nnn)      
          F                = VFtab(nnn+1)    
          Geps             = eps*VFtab(nnn+2)
          Heps2            = eps2*VFtab(nnn+3)
          Fp               = F+Geps+Heps2    
          VV               = Y+eps*Fp        
          vcoul            = qq*VV           
          vctot            = vctot + vcoul   
          r                = rsq31*rinv31    
          rt               = r*tabscale      
          n0               = rt              
          eps              = rt-n0           
          eps2             = eps*eps         
          nnn              = 12*n0+1         
          Y                = VFtab(nnn)      
          F                = VFtab(nnn+1)    
          Geps             = eps*VFtab(nnn+2)
          Heps2            = eps2*VFtab(nnn+3)
          Fp               = F+Geps+Heps2    
          VV               = Y+eps*Fp        
          vcoul            = qq*VV           
          vctot            = vctot + vcoul   
          qq               = qM*jq           
          r                = rsq41*rinv41    
          rt               = r*tabscale      
          n0               = rt              
          eps              = rt-n0           
          eps2             = eps*eps         
          nnn              = 12*n0+1         
          Y                = VFtab(nnn)      
          F                = VFtab(nnn+1)    
          Geps             = eps*VFtab(nnn+2)
          Heps2            = eps2*VFtab(nnn+3)
          Fp               = F+Geps+Heps2    
          VV               = Y+eps*Fp        
          vcoul            = qq*VV           
          vctot            = vctot + vcoul   
        end do
        
        ggid             = gid(n)+1        
        Vc(ggid)         = Vc(ggid) + vctot
        Vvdw(ggid)       = Vvdw(ggid) + Vvdwtot
      end do
      
      outeriter        = nri             
      inneriter        = nj1             
      return
      end



